/*
 * nuke.h
 *
 * things having to do with nukes
 *
 * Dave Pare, 1986
 * $Revision: 1.4 $ $Date: 89/09/02 13:42:54 $
 */

#define	N_MAXNUKE	15

struct	nukstr {
	coord	nuk_x;		/* current loc of device */
	coord	nuk_y;
	natid	nuk_own;
	s_char	nuk_n;		/* number of nukes in list */
	short	nuk_uid;
	short	nuk_ship;	/* currently aboard ship */
	short	nuk_trade;	/* index into trade file */
	s_char	nuk_types[N_MAXNUKE];	/* # of nukes in sector of given type */
};

struct nchrstr {
	s_char *n_name;		/* warhead unit name */
	int n_lcm;		/* costs to build */
	int n_hcm;
	int n_oil;
	int n_rad;
	int n_blast;		/* blast radius */
	int n_dam;		/* damage at center */
	int n_cost;
	int n_tech;		/* tech needed to build */
	int n_weight;
	int n_flags;		/* description of capability */
};

#ifdef	NEUTRON
#define	N_NEUT	bit(0)		/* Neutron bomb (low damage, high fallout) */
#endif	NEUTRON

#define getnuke(n, p) \
	ef_nbread(EF_NUKE, n, (caddr_t)p)
#define putnuke(n, p) \
	ef_nbwrite(EF_NUKE, n, (caddr_t)p)
#define getnukep(n) \
	(struct nukstr *) ef_ptr(EF_NUKE, n)

extern  struct nchrstr nchr[];
