.TH Command ATTACK
.SY "attack <SECT> <move in?>"

The attack command is used to conquer sectors owned by other
countries. It should not be used to take over unoccupied
sectors (\*Qexplore\*U does that more efficiently). Also, attack
will not let you attack your own sectors. If the SLOW_WAR
option is in use, attack will not let you attack the sectors of
any country you are not at war with. (See info relations)
(If the SNEAK_ATTACK option is ALSO in use, you will be able to
sneak attack 1 sector of a nation you are not at war with. This
will cost you $5K, whether you win or not. After the sneak attack,
you will automatically declare war on them)
.s1
To attack sector 12,-6 you would type:
.EX attack 12,-6
This will initiate the attack sequence against sector
12,-6 (note: you may only attack one sector at a time).
Empire will then ask you if you would like to move into the sector
in the event you win.
You should reply with a \*Qy\*U or \*Qn\*U.
.s3
Then you will be informed of the sector's status, e.g.
.NF
	Sector 12,-6 is a 15% fortress with approximately 40 military.
.FI
.s3
Then, for each sector you own that is adjacent to the target sector, you
will then be asked whether or not to attack with each land
unit in that sector, then asked how many military you wish to 
attack with from that sector.
.ti 3
.NF
Attack with War Band #0 (100%)? y
Number of troops from airfield at 2,0 (max 31) : 10
.FI
.br
The cost in mobility to the attacking sector(s) depends on the terrain:
.s1
.ne 8
.NF
\&              Mobility Cost (Per Military) in Attacks
\&
\&                      sector type being attacked
\&
\&                      |  (+) |  (-) |  (^) |  (?) |
\&                  ----+------+------+------+------+
\&          Highway (+) | .125 | .291 | 21.3 | .208 |
\&   F              ----+------+------+------+------+
\&   R   Wilderness (-) | .208 | .375 | 21.4 | .291 |
\&   O              ----+------+------+------+------+
\&   M     Mountain (^) | 10.7 | 10.9 | 31.9 | 10.8 |
\&                  ----+------+------+------+------+
\&           others (?) | .167 | .333 | 21.3 | .250 |
\&                  ----+------+------+------+------+
.FI
.s3
The cost in mobility to the defending sector is the same as for the attacking
sector if the attack is unsuccessful.
.s3
Units attacking pay a mobility penalty, (10 * (casualties/total mil))
Casualties is the number of casualties suffered by that side in the battle.
Total mil is the total number of mil on that side, counting both mil, and 
mil in land units. (For example, a unit that takes 100 mil to build and is
at 50% efficiency contains 50 mil)
.s3
Units in the sector being attacked pay the same.
.s3
Units reacting to an attack also pay the same, 
unless they are on a reserve mission, in which case they pay
half that amount.
.s3
Attacking units and units reacting to an attack also pay mobility to
move into the threatened sector. Reacting units get to move back to 
their starting point for free, providing they're not forced to retreat.
(See the explanation later on in this document)
.s3
.L Supply
.s3
When attacking or defending, units may use supply.
The chance to use supply depends on the loss percentage the unit's 
side takes. The more intense the combat, the more chance the unit will
use supplies.
When using supplies, each unit uses food, some use shells,
and some use fuel. See info supply for more details.
.s3
Once you have allocated all your attacking forces, the program will show
you the initial strengths. Each mil counts as 1. Land units count as the
number of mil in them times their offensive or defensive multiplier, as
appropriate. (To show the multipliers, see the show command). For example,
if it took 100 mil to build a unit, and it had an attack multiplier of 2.5,
it would be worth 250 "mil-equivalents" when attacking.
.ti 3
.NF
Total attack strength = 110
Initial defense strength = 40
.FI
.s3
These strengths include terrain effects. To see the terrain effects multipliers,
use the \*Qshow\*U command ("show sect stats", see info show for more details).
.s3
After this, additional enemy land units have the opportunity to react and enter
the threatened sector. If the defender has less than 1.2 times the 
attackers strength, available units will move to the target sector. Once
the defender's strength is 20% more than the attackers, no more units will
react. (Note that defending units moving to the target sector could take
damage from enemy units doing interdiction missions on the sectors they pass
through. This could result in the unit being considerably smaller when it
arrives than when it started! See info mission for more details)
.s3
In order to react, a unit must be \*Qin supply\*U (see info supply for a
definition), and have a non-zero reaction radius. Units with a basic reaction
radius of 0 can never react. Units whose reaction radius is set with 
\*Qlrangeedit\*U to 0 will not react until their radius is changed back
to a non-zero value. (the reaction radius of a unit
can be printed using the show land stats command. See info show)
.s3
The distance to the target sector must be less than or
equal to the reaction radius of the unit. Units in
a headquarters sector receive a +1 bonus, provided the headquarters is at
least 60% efficient. Units performing a reserve mission (see info mission)
get a +2 bonus. The unit must also have an efficiency above it's retreat
percentage, and have enough mobility to reach the target sector.
(Also, units will not react into mountains, even if they have the mobility)
.s3
Once all reaction is finished, a new set of strengths is printed:
.ti 3
.NF
Total attack strength = 110
Total defense strength = 140
.FI
.s3
Now, support is calculated, attackers fire, then defenders.
Each fort/ship/land unit that is within firing
range of the target sector and supplied will fire, including those in the 
attacked sector, and artillery units that react to the attacked sector.
(Forts and ships must be at least 60% efficient)
Planes with support
missions will attempt to fly to the sector and contribute support as well.
Support contributed is equal to the damage normally done by the unit, 
divided by 100. For example, if a fort contributes support, and would normally
do 15% damage, it would contribute .15 support.
.s3
Land units support depends on their accuracy & damage rating. If a random
roll is greater than the accuracy, they do full damage, otherwise it is
halved.
.s3
Defending forts/ships/units/planes only contribute support if it is needed.
(If the defender's  strength is at least 20% more than
the attackers, they don't fire)
.s3
Mines in the defending sector contribute .02 support per mine, with a maximum
of .4 support. (If the attacker has at least 1 engineering unit, however, the
mine support is halved)
.s3
All support is listed:
.ti 3
.NF
Defending forts add 0.15
Defending ships add 0.00
Defending units add 0.05
Defending mines add 0.10
Defending planes add 0.20
Attacking forts add 0.00
Attacking ships add 0.35
Attacking units add 0.00
Attacking planes add 0.35
.FI
.s3
The attacker's strength is multiplied by (1+asupport), and the defenders
is multiplied by (1+dsupport). Then, new totals are printed:
.ti 3
.NF
Total attack strength = 187
Total defense strength = 210
.FI
.s1
Once the total strengths have been figured, the battle will rage until someone
is wiped out. Each time a casualty is done, a character is typed;
\*Q!\*U if a defending soldier got it,
\*Q@\*U if an attacking soldier went down
.s3
Each casualty is 1 mil, or a loss of efficiency from a land unit.
Mil take casualties first. When there are no more mil left on a side,
land units take the casualties. When a land unit takes a casualty, it
loses efficiency. If it is a 100 mil land unit (see show land build),
each casualty is 1% of efficiency lost. If it is a 50 mil land unit,
each casualty is 2%, etc. When a land unit takes a casualty, and the unit's
efficiency is less than or equal to it's retreat percentage, it must then make
a morale check.
.s3
The chance of failing a morale check is: sqrt(100-effic)%.
Example: a unit is at 75% efficiency. It's chance of failing is
sqrt(100-75)% = sqrt(25)% = 5%
.s3
When a unit fails a morale check, it will attempt to retreat to the adjacent
owned sector with the greatest number of civilians in it. If there are no owned
sectors adjacent, the unit will take extra casualties instead. (No unit will
retreat into a mountain sector) A unit that retreats pays the normal movement
cost to enter the sector it retreats to (see info march for movement costs for 
units). The unit CAN retreat even if it has
no mobility, and will go negative to pay for it. The most a unit can go
negative is -127. After that, it won't pay any cost to retreat (although by
then it's probably pretty useless as a unit)
.s3
After each casualty, the total attack and defense strength are refigured.
(Support is not re-figured, it remains constant). If one side has been
eliminated, the battle is over.. Otherwise, the slaughter continues.
.s1
When the battle is done, it's time to count the costs. You'll pay .15 BTU's
for each casualty in the battle.
.s1
If you lose, tough! However, if you win, and you have specified you wish
to move in after your victory, some of your surviving attacking forces
will move into the victim's sector. For example, if three sectors were
attacking one quarter of the attack forces will occupy the conquered sector.
All attacking land units that did not retreat from the battle will also
move into the attacked sector.
.s3
When planning an attack remember that overwhelming forces greatly increases
your odds; i.e., attacking 10 men with 40 will result in your losing
fewer troops than if you had attacked with 20.
.s1
If the SLOW_WAR option is enabled, you will not be able to attack
a sector owned by a country you are not AT_WAR with, unless you
are the old owner of the sector.
.s1
If the SNEAK_ATTACK option is also enabled, you can attack ONE sector
owned by a country you are not AT_WAR with, paying $5K for the
privilege. Once the sneak attack is done, you will automatically
declare war against the enemy, and go through the normal SLOW_WAR
sequence before you can attack again (see info declare or info
relations).
.s1
A few notes:
.s3
A sector is damaged by combat that takes place there. For every 10 casualties,
the efficiency of the sector drops by 1%.
.s3
The deity (country 0) is believed to be pacifistic and unlikely to
help attackers,
(except in response to a large offering on the Religious Holidays).
.s3
If you successfully take the sector over,
then the civilians will be turned into \*Qconquered populace\*U
(see \*Qinfo populace\*U for details),
unless the sector was previously yours.
.L INTELLIGENCE
.s1
At times during the battle, you may get information about enemy land
units. The amount of information you find out depends on the spy values
of the land units you have in the battle. (Recon units tend to have spy
values and get an extra bonus at this) This information is not necessarily
precisely completely correct, of course.
.s3
Finally, before initiating an attack you should consider whether
the real answer to your problem might lie in diplomacy
(you heavy-handed clod!)
.s3
See also : assault, fire, march, move, prayers, telegram, relations
