static char *RCSid = "$Header: /sequent2/empire/EMP/lib/global/RCS/land.c,v 1.2 89/09/10 21:37:57 mr-frog Exp $";

/*
 * land.c
 *
 * land unit chjaracteristics
 * 
 */

#include "misc.h"
#include "var.h"
#include "land.h"

struct  lchrstr lchr[]  = {

/* name
   lcm, hcm, mil, gun, shell, tech,   $,
   att, def, vul, spd, vis, spy, rad, frg, acc, dam, amm, aaf, fc, fu, xpl,
   flags, nv
   cargo
*/
/* ((int)(ETUS/(mil/1000)))*3 is enough food for 3 updates */

{ "infantry 1",
    10,   5,  50,   0,    0,     0, 500,
   1.0, 1.5,  60,  23,  15,   2,   1,   0,   0,   0,   0,   0,  0,  0,   0,
   L_ASSAULT|L_LIGHT, 1,
   {             V_FOOD },
   { ((int)(ETUS/10))*3 }, },

{ "supply 1",
    10,   5,  25,   0,    0,     0, 500,
   0.1, 0.2, 100,  15,  20,   1,   0,   0,   0,   0,   0,   0,  0,  0,   0,
   L_LIGHT|L_SUPPLY, 8,
   { V_SHELL,V_GUN,V_FOOD,V_LCM,V_HCM,V_DUST,V_BAR,V_IRON,},
   {     200,   10,   300,  200,  100,   100,   10,   100,}, },

{ "cavalry",
    10,   5,  25,   0,    0,     0, 500,
   2.0, 0.8,  80,  32,  18,   4,   3,   0,   0,   0,   0,   0,  0,  0,   0,
   L_RECON|L_LIGHT, 1,
   {             V_FOOD, },
   { ((int)(ETUS/20))*3, }, },

{ "infantry 2",
    10,   5,  50,   1,    2,    20, 500,
   1.0, 2.0,  60,  23,  15,   2,   1,   0,   0,   0,   1,   1,  0,  0,   0,
   L_ASSAULT|L_LIGHT, 2,
   {             V_FOOD, V_SHELL },
   { ((int)(ETUS/10))*3,       3 }, },

{ "artillery 1",
    20,  10,  50,  10,   20,    20, 800,
   0.1, 0.4,  70,  15,  20,   1,   0,   4,  50,   8,   4,   1,  0,  0,   0,
   L_LIGHT, 2,
   {             V_FOOD, V_SHELL, },
   { ((int)(ETUS/10))*3,      20, }, },

{ "supply 2",
    10,   5,  25,   0,    0,    20, 500,
   0.1, 0.2,  90,  23,  20,   1,   0,   0,   0,   0,   0,   0,  0,  0,   0,
   L_LIGHT|L_SUPPLY, 9,
   { V_SHELL,V_GUN,V_FOOD,V_LCM,V_HCM,V_DUST,V_BAR,V_IRON,V_PETROL},
   {     200,   10,   300,  200,  100,   100,   10,   100,     100}, },

{ "hvy artillery 1",
    40,  20,  50,  20,   40,   100, 800,
   0.0, 0.2,  60,  10,  20,   1,   0,   7,  99,  10,   6,   1,  0,  0,   0,
   0, 2,
   {             V_FOOD, V_SHELL, },
   { ((int)(ETUS/10))*3,      30, }, },

{ "lt artillery",
    20,  10,  25,  10,   20,   100, 500,
   0.2, 0.6,  60,  21,  18,   1,   1,   3,  10,   4,   2,   1,  0,  0,   0,
   L_LIGHT, 2,
   {             V_FOOD, V_SHELL, },
   { ((int)(ETUS/20))*3,      10, }, },

{ "hvy armor 1",
    20,  10,  50,   5,   10,   120, 500,
   2.0, 0.8,  50,  15,  17,   1,   1,   0,   0,   0,   2,   1, 10,  2,   0,
   0, 2,
   {             V_FOOD, V_SHELL, },
   { ((int)(ETUS/10))*3,       3, }, },

{ "engineer 1",
    10,   5,  10,   2,    4,   130,1000,
   1.2, 2.4,  50,  23,  14,   2,   1,   0,   0,   0,   1,   1,  0,  0,   0,
   L_ENGINEER|L_ASSAULT|L_LIGHT, 2,
   {             V_FOOD, V_SHELL, },
   { ((int)(ETUS/40))*3,       3, }, },

{ "infantry 3",
    10,   5,  50,   2,    4,   150, 500,
   1.2, 2.2,  60,  23,  15,   2,   1,   0,   0,   0,   1,   2,  0,  0,   0,
   L_ASSAULT|L_LIGHT, 2,
   {             V_FOOD, V_SHELL },
   { ((int)(ETUS/10))*4,       4 }, },

{ "hvy armor 2",
    20,  10,  50,   5,   10,   150, 500,
   2.5, 1.0,  40,  23,  17,   1,   1,   0,   0,   0,   1,   2, 10,  1,   0,
   0, 2,
   {             V_FOOD, V_SHELL, },
   { ((int)(ETUS/10))*4,       6, }, },

{ "artillery 2",
    20,  10,  50,  10,   20,   150, 800,
   0.1, 0.4,  60,  15,  20,   1,   0,   5,  35,   8,   4,   2,  0,  0,   0,
   L_LIGHT, 2,
   {             V_FOOD, V_SHELL, },
   { ((int)(ETUS/10))*4,      20, }, },

{ "hvy artillery 2",
    40,  20,  50,  20,   40,   150, 800,
   0.0, 0.2,  50,  11,  20,   1,   0,   7,  95,  12,   6,   2,  0,  0,   0,
   0, 2,
   {             V_FOOD, V_SHELL, },
   { ((int)(ETUS/10))*4,      30, }, },

{ "lt armor 1",
    10,   5,  25,   3,    5,   150, 500,
   2.0, 1.0,  50,  42,  15,   4,   4,   0,   0,   0,   1,   2, 25,  1,   0,
   L_RECON|L_LIGHT, 2,
   {             V_FOOD, V_SHELL, },
   { ((int)(ETUS/20))*4,       4, }, },

{ "engineer 2",
    10,   5,  10,   2,    4,   165,1000,
   1.5, 2.6,  50,  23,  14,   2,   1,   0,   0,   0,   1,   4,  0,  0,   0,
   L_ENGINEER|L_ASSAULT|L_LIGHT, 2,
   {             V_FOOD, V_SHELL, },
   { ((int)(ETUS/40))*4,       4, }, },

{ "armor 1",
    20,  10,  25,   3,    5,   170, 800,
   3.0, 1.5,  40,  32,  16,   2,   2,   0,   0,   0,   1,   2, 13,  1,   0,
   L_LIGHT, 2,
   {             V_FOOD, V_SHELL, },
   { ((int)(ETUS/20))*4,       4, }, },

{ "security",
    10,   5,  25,   2,    4,   170, 400,
   1.0, 2.0,  60,  23,  15,   2,   1,   0,   0,   0,   1,   1,  0,  0,   0,
   L_SECURITY|L_LIGHT, 2,
   {             V_FOOD, V_SHELL },
   { ((int)(ETUS/20))*4,       4 }, },

{ "motor inf",
    15,  10,  50,   2,    4,   190, 600,
   1.2, 2.2,  60,  32,  17,   1,   3,   0,   0,   0,   2,   3, 13,  1,   0,
   L_LIGHT, 2,
   {             V_FOOD, V_SHELL },
   { ((int)(ETUS/10))*4,       8 }, },

{ "mech inf 1",
    15,  10,  50,   2,    4,   190, 800,
   1.5, 2.5,  50,  32,  17,   1,   3,   0,   0,   0,   2,   3, 13,  1,   0,
   L_LIGHT, 2,
   {             V_FOOD, V_SHELL },
   { ((int)(ETUS/10))*4,       8 }, },

{ "marines",
    10,   5,  50,   2,    4,   190,1000,
   1.4, 2.4,  60,  23,  14,   2,   1,   0,   0,   0,   1,   2,  0,  0,   0,
   L_MARINE|L_ASSAULT|L_LIGHT, 2,
   {             V_FOOD, V_SHELL },
   { ((int)(ETUS/10))*4,       4 }, },

{ "lt armor 2",
    10,   5,  25,   3,    5,   190, 600,
   2.5, 1.5,  45,  48,  14,   5,   5,   0,   0,   0,   2,   3, 25,  1,   0,
   L_RECON|L_LIGHT, 2,
   {             V_FOOD, V_SHELL, },
   { ((int)(ETUS/20))*4,       8, }, },

{ "aa unit 1",
    10,   5,  10,   5,   10,   200, 800,
   0.5, 3.0,  50,  32,  17,   1,   1,   0,   0,   0,   2,  10, 13,  1,   0,
   L_LIGHT, 2,
   {             V_FOOD, V_SHELL, },
   { ((int)(ETUS/40))*4,       8, }, },

{ "mech arty 1",
    20,  10,  25,  10,   20,   200,1000,
   0.2, 0.6,  50,  32,  17,   1,   1,   5,  35,   8,   6,   3, 13,  1,   0,
   L_LIGHT, 2,
   {             V_FOOD, V_SHELL, },
   { ((int)(ETUS/20))*4,      30, }, },

{ "armor 2",
    20,  10,  25,   3,    5,   210, 900,
   4.0, 2.0,  30,  35,  15,   2,   3,   0,   0,   0,   2,   3, 25,  2,   0,
   L_LIGHT, 2,
   {             V_FOOD, V_SHELL, },
   { ((int)(ETUS/20))*4,       8, }, },

{ "mech inf 2",
    20,  10,  50,   3,    5,   250, 800,
   1.5, 2.9,  48,  32,  17,   1,   3,   0,   0,   0,   2,   3, 13,  1,   0,
   L_LIGHT, 2,
   {             V_FOOD, V_SHELL },
   { ((int)(ETUS/10))*4,       8 }, },

{ "lt armor 3",
    10,   5,  25,   3,    5,   250, 600,
   3.0, 1.8,  40,  50,  13,   5,   5,   0,   0,   0,   3,   4, 50,  2,   0,
   L_RECON|L_LIGHT, 2,
   {             V_FOOD, V_SHELL, },
   { ((int)(ETUS/20))*4,      12, }, },

{ "mech engineer",
    10,   5,  10,   3,    5,   260,1500,
   1.8, 3.5,  45,  32,  15,   3,   3,   0,   0,   0,   1,   5, 25,  2,   0,
   L_ENGINEER|L_ASSAULT|L_LIGHT, 2,
   {             V_FOOD, V_SHELL, },
   { ((int)(ETUS/40))*4,       4, }, },

{ "armor 3",
    20,  10,  25,   3,    5,   265, 900,
   5.0, 2.2,  25,  38,  15,   3,   3,   0,   0,   0,   3,   4, 50,  4,   0,
   L_LIGHT, 2,
   {             V_FOOD, V_SHELL, },
   { ((int)(ETUS/20))*4,      12, }, },

{ "supply 3",
    10,   5,  25,   0,    0,   265, 500,
   0.1, 0.2,  80,  32,  20,   1,   0,   0,   0,   0,   0,   0, 13,  1,   0,
   L_LIGHT|L_SUPPLY, 9,
   { V_SHELL,V_GUN,V_FOOD,V_LCM,V_HCM,V_DUST,V_BAR,V_IRON,V_PETROL},
   {     200,   10,   300,  200,  100,   100,   10,   100,     300}, },

{ "mech inf 3",
    20,  10,  50,   3,    5,   270, 800,
   1.6, 3.2,  45,  32,  15,   3,   4,   0,   0,   0,   4,   6, 36,  3,   2,
   L_XLIGHT|L_LIGHT, 2,
   {             V_FOOD, V_SHELL },
   { ((int)(ETUS/10))*4,      16 }, },

{ "radar unit 1",
    10,   5,  10,   0,    0,   270,1000,
   0.0, 0.0,  50,  32,  15,   3,   0,   0,   0,   0,   0,   2, 25,  2,   1,
   L_XLIGHT|L_RADAR|L_LIGHT, 1,
   {             V_FOOD, },
   { ((int)(ETUS/10))*4, }, },

{ "mech arty 2",
    20,  10,  25,  10,   20,   270,1000,
   0.1, 0.4,  40,  38,  15,   1,   2,   6,  30,   8,   8,   6, 36,  3,   2,
   L_XLIGHT|L_LIGHT, 2,
   {             V_FOOD, V_SHELL, },
   { ((int)(ETUS/20))*4,      40, }, },

{ "aa unit 2",
    10,   5,  10,   3,    5,   290,1200,
   0.5, 2.0,  45,  32,  15,   3,   1,   0,   0,   0,   3,  14, 36,  3,   4,
   L_XLIGHT|L_LIGHT, 2,
   {             V_FOOD, V_SHELL, },
   { ((int)(ETUS/40))*4,      12, }, },

{ "armor 4",
    20,  10,  25,   3,    5,   305,1000,
   6.0, 3.0,  20,  40,  15,   3,   4,   0,   0,   0,   4,   6, 60,  5,   2,
   L_XLIGHT|L_LIGHT, 2,
   {             V_FOOD, V_SHELL, },
   { ((int)(ETUS/20))*4,      16, }, },

{ "mech inf 4",
    20,  10,  50,   3,    5,   310,1000,
   1.8, 3.5,  35,  40,  14,   3,   5,   0,   0,   0,   5,   8, 50,  4,   2,
   L_XLIGHT|L_LIGHT, 2,
   {             V_FOOD, V_SHELL },
   { ((int)(ETUS/10))*4,      32 }, },

{ "mech arty 3",
    20,  10,  25,  10,   20,   310,1200,
   0.1, 0.4,  40,  40,  14,   1,   2,   7,  20,   8,   8,   8, 50,  4,   4,
   L_XLIGHT|L_LIGHT, 2,
   {             V_FOOD, V_SHELL, },
   { ((int)(ETUS/20))*4,      40, }, },

{ "radar unit 2",
    10,   5,  10,   0,    0,   320,1000,
   0.0, 0.0,  50,  32,  14,   5,   0,   0,   0,   0,   0,   4, 25,  2,   2,
   L_XLIGHT|L_RADAR|L_LIGHT, 1,
   {             V_FOOD, },
   { ((int)(ETUS/10))*4, }, },

{ "armor 5",
    20,  10,  25,   3,    5,   350,1200,
   8.0, 3.5,  15,  45,  14,   3,   5,   0,   0,   0,   5,   8, 60,  4,   4,
   L_XLIGHT|L_LIGHT, 2,
   {             V_FOOD, V_SHELL, },
   { ((int)(ETUS/20))*4,      20, }, },

{ "mech inf 5",
    20,  10,  50,   3,    5,   355,1200,
   2.0, 4.0,  30,  45,  14,   3,   5,   0,   0,   0,   5,   8, 60,  4,   4,
   L_XLIGHT|L_LIGHT, 2,
   {             V_FOOD, V_SHELL },
   { ((int)(ETUS/10))*4,      20 }, },

{ "aa unit 3",
    10,   5,  10,   3,    5,   350,1200,
   0.5, 1.5,  45,  32,  14,   3,   1,   0,   0,   0,   2,  18, 36,  3,   8,
   L_XLIGHT|L_LIGHT, 2,
   {             V_FOOD, V_SHELL, },
   { ((int)(ETUS/40))*4,       8, }, },
/* name
   lcm, hcm, mil, gun, shell, tech,   $,
   att, def, vul, spd, vis, spy, rad, frg, acc, dam, amm, aaf, fc, fu, xpl,
   flags, nv
   cargo
*/

{  "",
     0,   0,   0,   0,    0,     0,   0,
     0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,  0,  0,   0,
    0,  0,
    { 0 },
    { 0 }, }
};

int	lnd_maxno = (sizeof(lchr) / sizeof(struct lchrstr)) - 1;
