static char *RCSid = "$Header: /sequent2/empire/EMP/lib/global/RCS/news.c,v 1.1 89/09/02 18:30:16 mr-frog Exp $";

/*
 * news.c
 *
 * News item characteristics; one entry (and two different
 * strings) per news item.  Be sure and increase N_MAX_VERB
 * in news.h if you add a news item.
 *
 * Order must correspond to ordering in news.h
 * 
 */

#include "misc.h"
#include "news.h"

struct  rptstr rpt[N_MAX_VERB+1] = {
/*  nice    page    text
*/  0,      3,      "does nothing in particular to %s",
		    "does nothing to %s",
    -4,     1,      "infantry capture %s territory",
		    "shock troops overrun one of %s's sectors",
    -4,     1,      "infantry beaten back by %s troops",
		    "shock troops annihilated in failed attack on %s",
    -1,     2,      "spy shot by %s firing squad",
		    "spy captured and shot by %s",
    1,      2,      "sends a telegram to %s",
		    "telexes %s",
    3,      3,      "diplomats sign a treaty with %s",
		    "ambassador agrees to a treaty with %s",
    2,      3,      "bankers make a loan to %s",
		    "Ministry of Finance lends money to %s",
    1,      3,      "repays a loan from %s",
		    "makes last payment on loan from %s",
    0,      3,      "makes a sale to %s",
		    "sells goods to %s",
    -1,     1,      "violates %s airspace",
		    "overflies %s territory",
    -2,     1,      "gunners bombard %s territory",
		    "artillery fires on %s sectors",
    -2,     1,      "shells a ship owned by %s",
		    "fires on %s ships",
    0,      2,      "takes over unoccupied land",
		    "attacks unowned land for some reason",
    0,      1,      "ships torpedoed by enemy wolf-packs",
		    "ships torpedoed by marauding U-boats",
    0,      1,      "gunners fire on %s in self-defense",
		    "gunners decimate %s aggressors",
    0,      2,      "breaks sanctuary",
		    "no longer has a sanctuary",
    -2,     1,      "planes divebomb one of %s's sectors",
		    "bombers wreak havoc on %s",
    -2,     1,      "divebombs a ship flying the flag of %s",
		    "airforce bombs %s ships",
    -2,     1,      "seadogs board one of %s's ships",
		    "pirates board %s ship",
    -3,     1,      "is repelled by %s while attempting to board a ship",
		    "pirates prove inept at boarding %s's ships",
    -1,     1,      "anti-aircraft gunners fire on %s airforce",
		    "attempts to shoot down %s aircraft",
    -2,     3,      "seizes a sector from %s to collect on a loan",
		    "collects one of %s's sectors in repayment of a loan",
    -1,     2,      "considers an action which would violate a treaty with %s",
		    "decides not to violate treaty with %s (yet)",
    -4,     1,      "violates a treaty with %s",
		    "actions violate treaty with %s",
    0,      1,      "dissolves its government",
		    "throws in the towel",
    0,      1,      "ship hits a mine",
		    "ship severely damaged in mine field",
    5,      1,      "announces an alliance with %s",
		    "/ %s alliance declared",
    0,      1,      "declares their neutrality toward %s", /* no longer used */
		    "announces neutral relations with %s",
    -5,     1,      "declares TOTAL WAR on %s",
		    "gets serious with %s and declares WAR",
    -5,     1,      "diplomats disavow former alliance with %s",
		    "is no longer allied with %s",
    5,      1,      "is no longer at war with %s",
		    "Foreign Ministry declares \"No more war with %s\"",
    0,      1,      "reports outbreak of the black plague",
		    "sector infected with bubonic plague",
    0,      2,      "citizens die from bubonic plague",
		    "sector reports plague deaths",
    0,      2,      "goes through a name change",
		    "adopts a new country name",
    0,      2,      "citizens starve in disastrous famine",
		    "loses citizens to mass starvation",
    0,      2,      "endures lawless rioting",
		    "suffers from outbreaks of rioting",
    -3,     1,      "pilots down %s planes",
		    "victorious in air-to-air combat against %s",
    -10,    1,      "nuclear device devastates %s sector",
		    "explodes a nuclear device damaging %s territory",
    0,      1,      "terrorists shoot it out with %s special forces",
		    "underground rises up against %s occupation",
    -2,     1,      "execution squads gun down helpless %s civilians",
		    "firing squads massacre defenseless %s workers",
     0,     1,      "launches a satellite into orbit",
		    "continues its conquest of space with a successful launch",
    -8,     1,      "strikes a %s big bird",
		    "rockets damage a %s satellite",
     4,     1,      "makes a contribution to %s",
		    "helps out %s",
     2,     1,      "aids %s with divine intervention",
		    "smiles upon %s",
    -3,     1,      "hurts %s with divine intervention",
		    "frowns upon %s",
    -4,     1,      "sacrifices to %s",
		    "makes divine payment to %s",
    -10,    1,      "nuclear device is intercepted by %s abms",
		    "nuclear warhead destroyed by %s strategic defense systems",
    -2,     1,      "missile fired at one of %s's sectors",
		    "missile wreaks havoc on %s",
    -2,     1,      "missile fired at a ship flying the flag of %s",
		    "missiles hit %s ships",
     2,     3,      "engages in peaceful trade with %s",
                    "profits from a merchant venture with %s",
     0,     1,      "pirates dispose of %s booty in trade",
                    "buccaneers sell their %s goods",
     0,     1,      "pirates keep their %s booty",
                    "buccaneers laugh and bury their %s goods",
     0,     1,      "ships torpedoed by %s torpedo-boats",
		    "ships sunk by marauding %s torpedo-boats",
     0,     1,      "planes bomb a skulking %s submarine",
		    "planes drop depth-charges on a %s sub",
     -2,    1,      "ship is blown up in a failed assault on %s",
		    "has a ship destroyed while assaulting %s",
    -2,     1,      "divebombs a brave %s unit",
		    "airforce bombs %s units",
    0,      1,      "unit runs afoul of a landmine",
		    "unit severely damaged in mine field",
    -2,     1,      "fortress gunners support troops attacking %s",
		    "fortress artillery massacres %s defenders",
    -2,     1,      "gunners support troops attacking %s",
		    "artillery units massacre %s defenders",
    -2,     1,      "naval gunners support troops attacking %s",
		    "naval gunfire massacres %s defenders",
};
