#ifndef lint
static char *RCSid = "$Header: /sequent2/empire/EMP/player/commands/RCS/newe.c,v 1.12 89/09/10 17:24:57 mr-frog Exp $";
#endif

/*
 * newe.c
 *
 * Show new efficiency (projected)
 *
 * --ts 1993
 */

#include "misc.h"
#include "var.h"
#include "xy.h"
#include "nsc.h"
#include "sect.h"
#include "product.h"
#include "nat.h"
#include "tm.h"
#include "item.h"
#include "file.h"

int
newe()
{
	extern	s_char *argp[];
	extern	double obrate, uwbrate; 
	extern	int etu_per_update;
	struct	natstr *natp;
	struct	sctstr sect;
	struct	nstr_sect nstr;
	struct	pchrstr *pp;
	double  effic;
	double  maxr;		    /* floating version of max */
	double  work, wforce, lcms, hcms, vec[I_MAX+1];
	int     i, items[I_MAX+1];
	int     nsect;
	int     it;
	int     c;
#ifdef BUDGET
	int	civs=0;
	int	uws=0;
#endif /* BDUGET */
#ifdef MERC
	int	bwork;
	int	twork;
	int	type;
	int	eff;
#endif
	int	maxpop;

	if (!snxtsct(&nstr, argp[1]))
		return RET_SYN;
	prdate();
	nsect = 0;
	while (nxtsct(&nstr, &sect)) {
		if (!owner)
			continue;

                getvec(VT_ITEM, items, (s_char *)&sect, EF_SECTOR);

#ifdef BUDGET
                civs = min(999, (int) ((obrate * (double) etu_per_update + 1.0)
                       * (double) items[I_CIVIL]));
                uws = min(999, (int) ((uwbrate * (double) etu_per_update + 1.0)
                       * (double) items[I_UW]));
#else
		civs = items[I_CIVIL];
		uws = items[I_UW];
#endif /* BUDGET */
		natp = getnatp(sect.sct_own);
		maxpop = max_pop((float)natp->nat_level[NAT_RLEV]);
		civs = min(civs, maxpop);
		uws = min(uws, maxpop);
		/* This isn't quite right, since research might rise/fall */
		/* during the update, but it's the best we can really do  */
		wforce = (int)
			((civs * sect.sct_work) / 100.0
			+ uws + items[I_MILIT] * 2 / 5.0);

		work = etu_per_update * wforce / 100.0;
		bwork = work/2;

		type = sect.sct_type;
		eff = sect.sct_effic;
		if(sect.sct_newtype != type) {
			twork = (eff+3)/4;
			if(twork > bwork) {
				twork = bwork;
			}
			work -= twork;
			bwork -= twork;
			eff -= twork*4;
			if(eff <= 0) {
				type = sect.sct_newtype;
				eff = 0;
			}

			twork = 100 - eff;
			if(twork > bwork) {
				twork = bwork;
			}
			if (dchr[type].d_lcms>0){
                        	lcms = items[I_LCM];
                        	lcms = (int)(lcms/dchr[type].d_lcms);
                        	if (twork > lcms)
                                	twork = lcms;
			}
			if (dchr[type].d_hcms>0){
                        	hcms = items[I_HCM];
                        	hcms = (int)(hcms/dchr[type].d_hcms);
                        	if (twork > hcms)
                                	twork = hcms;
                	}
			work -= twork;
			eff += twork;
		}
		else if(eff < 100) {
			twork = 100 - eff;
			if(twork > bwork) {
				twork = bwork;
			}
			if (dchr[type].d_lcms>0){
                        	lcms = items[I_LCM];
                        	lcms = (int)(lcms/dchr[type].d_lcms);
                        	if (twork > lcms)
                                	twork = lcms;
			}
			if (dchr[type].d_hcms>0){
                        	hcms = items[I_HCM];
                        	hcms = (int)(hcms/dchr[type].d_hcms);
                        	if (twork > hcms)
                                	twork = hcms;
                	}
			work -= twork;
			eff += twork;
		}

		if (nsect++ == 0) {
			pr("EFFICIENCY SIMULATION\n");
			pr("   sect  des    projected eff\n");
		}
		pr(xyfmt("%4d,%-4d", nstr.x, nstr.y, cnum));
		pr(fmt(" %c", dchr[type].d_mnem));
		pr(fmt("    %3d%%\n", eff));
	}
	if (nsect == 0) {
		if (argp[1])
			pr(fmt("%s: No sector(s)\n", argp[1]));
		else
			pr(fmt("%s: No sector(s)\n", ""));
		return RET_FAIL;
	}else
		pr(fmt("%d sector%s\n", nsect, splur(nsect)));
	return RET_OK;
}
