#ifndef lint
static char *RCSid = "$Header: /users/empire/EMP/empmain/SUBS/RCS/supply.c,v 1.2 89/06/27 01:33:49 griffith Exp $";
#endif

/*
 * supply.c
 *
 * supply subroutines
 *
 */

#include "misc.h"
#include "nat.h"
#include "var.h"
#include "retreat.h"
#include "ship.h"
#include "land.h"
#include "sect.h"
#include "news.h"
#include "xy.h"
#include "nsc.h"
#include "path.h"
#include "deity.h"
#include "item.h"
#include "file.h"
#include "options.h"

/*
 * We want to get enough guns to be maxed out, enough shells to
 * 	fire once, one update's worth of food, enough fuel for
 *	one update.
 *
 * Firts, try to forage in the sector
 * Second look for a warehouse or headquarters to leech
 * Third, look for a ship we own in a harbor
 * Fourth, look for supplies in a supply unit we own
 * 		(one good reason to do this last is that the supply
 * 		 unit will then call resupply, taking more time)
 *
 */
supply(lp)
{
}

/*
 *
 * Get the Empire RDA for units :-)
 * May want to put code to resupply with SAMs here, later --ts
 *
 */

resupply_all(lp)
struct lndstr *lp;
{
#ifndef NOFOOD
	resupply_commod(lp,I_FOOD);
#endif /* NOFOOD */
	resupply_commod(lp,I_SHELL);
#ifdef FUEL
	resupply_commod(lp,I_PETROL);
#endif /* FUEL */
}

/*
 * If the unit has less than it's minimum level of a
 * certain commodity, fill it, to the best of our abilities.
 */

resupply_commod(lp, type)
struct	lndstr *lp;
int	type;
{
	int	vec[I_MAX+1];
	struct	lchrstr *lcp;

	lcp = &lchr[lp->lnd_type];

	getvec(VT_ITEM, vec, (s_char *)lp, EF_LAND);
	if (vec[type] < get_minimum(lp,type)){
		vec[type] += supply_commod(lp->lnd_x,lp->lnd_y,type,
			get_minimum(lp,type)-vec[type]);
		putvec(VT_ITEM, vec, (s_char *)lp, EF_LAND);
	}
#ifdef FUEL
	if (type == I_PETROL){
		extern	float land_mob_scale;
		extern	int etu_per_update;
		int	fuel_needed = (lcp->l_fuelu * (((float)etu_per_update
				* land_mob_scale))/10.0);

		while((lp->lnd_fuel < fuel_needed) && vec[I_PETROL]){
			lp->lnd_fuel += 10;
			if (lp->lnd_fuel > lcp->l_fuelc)
				lp->lnd_fuel = lcp->l_fuelc;
			vec[I_PETROL]--;
			putvec(VT_ITEM, vec, (s_char *)lp, EF_LAND);
		}
	}
#endif /* FUEL */
}

/*
 * Actually get the commod
 */
supply_commod(x, y, type,total_wanted)
int x, y, type, total_wanted;
{
	if (total_wanted < 0)
		return 0;

	return s_commod(x, y, type,total_wanted,1);
}

/*
 * Just return the number you COULD get, without doing it
 */
try_supply_commod(x, y, type,total_wanted)
int x, y, type, total_wanted;
{
	if (total_wanted < 0)
		return 0;

	return s_commod(x, y, type,total_wanted,0);
}

/* Get supplies of a certain type */
s_commod(x, y, type,total_wanted,actually_doit)
int x, y, type, total_wanted,actually_doit;
{
	int	wanted=total_wanted;
	int	gotten=0, lookrange;
	struct	sctstr sect, dest;
	int	vec[I_MAX+1];
	struct	nstr_sect ns;
	struct	nstr_item ni;
	struct	lchrstr *lcp;
	struct	shpstr ship;
	struct	lndstr land;
	/* leave at least 1 military in sectors/ships */
	int	minimum=(type == I_MILIT ? 1 : 0);
	int	can_move;
	double	supply_mob(), tfact(), move_cost, weight, mobcost;
	s_char	*BestLandPath();
	s_char	*itemname();
	int	own, packing;
	extern  double eatrate;
	extern  int etu_per_update;
	extern	float land_mob_scale;
	struct	dchrstr *dp;
	struct	ichrstr *ip;

	/* try to get it from sector we're in */
	getsect(x,y,&dest);
	getsect(x,y,&sect);
	own = sect.sct_own;

	getvec(VT_ITEM, vec, (s_char *)&sect, EF_SECTOR);
	if ((vec[type]-minimum) >= wanted){
		vec[type] -= wanted;

		if (actually_doit){
			putvec(VT_ITEM, vec, (s_char *)&sect, EF_SECTOR);
			putsect(&sect);
		}
		return total_wanted;
	}else if ((vec[type]-minimum) > 0){
		gotten += (vec[type]-minimum);
		wanted -= (vec[type]-minimum);

		vec[type] = minimum;
		if (actually_doit){
			putvec(VT_ITEM, vec, (s_char *)&sect, EF_SECTOR);
			putsect(&sect);
		}
	}

	/* look for a headquarters or warehouse */
	lookrange = tfact(own,(double)10.0);
	snxtsct_dist(&ns, x, y, lookrange);

	while (nxtsct(&ns, &sect) && wanted){
		if (sect.sct_own != own)
			continue;

		if ((sect.sct_type != SCT_WAREH) &&
			(sect.sct_type != SCT_HEADQ))
			continue;

		if ((sect.sct_type == SCT_HEADQ) &&
			(sect.sct_dist_x == sect.sct_x) &&
			(sect.sct_dist_y == sect.sct_y))
			continue;

		if (sect.sct_effic < 60)
			continue;

		if (BestLandPath(&dest,&sect,&move_cost) == (s_char *)0)
			continue;

		getvec(VT_ITEM, vec, (s_char *)&sect, EF_SECTOR);
#ifndef NOFOOD
		if (type == I_FOOD)
			minimum=((etu_per_update * eatrate) *
				(vec[I_CIVIL]+vec[I_MILIT]+vec[I_UW]))+1;
#endif /* NOFOOD */
		ip = &ichr[type];
		dp = &dchr[sect.sct_type];
		packing = ip->i_pkg[dp->d_pkg];
		if (packing > 1 && sect.sct_effic < 60)
			packing = 1;
		weight = ((double)ip->i_lbs / (double)packing);
		mobcost = move_cost * weight;
		can_move = ((double)sect.sct_mobil / mobcost);
		if (can_move > (vec[type]-minimum))
			can_move = (vec[type]-minimum);

		if (can_move >= wanted){
			vec[type] -= wanted;

			/* take off mobility for delivering sect */
			sect.sct_mobil -= roundavg(supply_mob(type,total_wanted,
					weight,move_cost));

			if (actually_doit){
				putvec(VT_ITEM, vec, (s_char *)&sect, EF_SECTOR);
				putsect(&sect);
			}

			return total_wanted;
		}else if (can_move > 0){
			gotten += can_move;
			wanted -= can_move;
			vec[type] -= can_move;

			/* take off mobility for delivering sect */
			sect.sct_mobil -= roundavg(supply_mob(type,can_move,
					weight, move_cost));

			if (actually_doit){
				putvec(VT_ITEM, vec, (s_char *)&sect, EF_SECTOR);
				putsect(&sect);
			}
		}
	}

	/* look for an owned ship in a harbor */
	snxtitem_dist(&ni, EF_SHIP, x, y, lookrange);

	while (nxtitem(&ni, &ship) && wanted){
		if (ship.shp_own != own)
			continue;

		if (!(mchr[ship.shp_type].m_flags & M_SUPPLY))
			continue;

		getsect(ship.shp_x,ship.shp_y,&sect);

		if (sect.sct_type != SCT_HARBR)
			continue;

		if (sect.sct_effic < 2)
			continue;

		if (BestLandPath(&dest,&sect,&move_cost) == (s_char *)0)
			continue;

		getvec(VT_ITEM, vec, (s_char *)&ship, EF_SHIP);
#ifndef NOFOOD
		if (type == I_FOOD)
			minimum=((etu_per_update * eatrate) *
				(vec[I_CIVIL]+vec[I_MILIT]+vec[I_UW]))+1;
#endif /* NOFOOD */
		
		ip = &ichr[type];
		dp = &dchr[sect.sct_type];
		packing = ip->i_pkg[dp->d_pkg];
		if (packing > 1 && sect.sct_effic < 60)
			packing = 1;
		weight = ((double)ip->i_lbs / (double)packing);
		mobcost = move_cost * weight;
		can_move = ((double)sect.sct_mobil / mobcost);
		if (can_move > (vec[type]-minimum))
			can_move = (vec[type]-minimum);

		if (can_move >= wanted){
			vec[type] -= wanted;

			sect.sct_mobil -= roundavg(supply_mob(type,wanted,
					weight, move_cost));

			if (actually_doit){
				putvec(VT_ITEM, vec, (s_char *)&ship, EF_SHIP);
				putship(ship.shp_uid,&ship);
				putsect(&sect);
			}
			return total_wanted;
		}else if (can_move > 0){
			gotten += can_move;
			wanted -= can_move;
			vec[type] -= can_move;

			sect.sct_mobil -= roundavg(supply_mob(type,can_move,
					weight, move_cost));

			if (actually_doit){
				putvec(VT_ITEM, vec, (s_char *)&ship, EF_SHIP);
				putship(ship.shp_uid,&ship);
				putsect(&sect);
			}
		}
	}

	/* look for an owned supply unit */
	snxtitem_dist(&ni, EF_LAND, x, y, lookrange);

	while (nxtitem(&ni, &land) && wanted){
		int	min;

		if (land.lnd_own != own)
			continue;

		lcp = &lchr[land.lnd_type];
		if (!(lcp->l_flags & L_SUPPLY))
			continue;

		if (at_minimum(&land,type))
			continue;

		getsect(land.lnd_x,land.lnd_y,&sect);
		if (BestLandPath(&dest,&sect,&move_cost) == (s_char *)0)
			continue;

		if ((land.lnd_ship >= 0) && (sect.sct_type != SCT_HARBR))
			continue;

		if ((land.lnd_ship >= 0) && (sect.sct_effic < 2))
			continue;

		getvec(VT_ITEM, vec, (s_char *)&land, EF_LAND);

		ip = &ichr[type];
		weight = ((double)ip->i_lbs);
		mobcost = move_cost * weight;
		can_move = ((double)land.lnd_mobil / mobcost);
		min = get_minimum(&land,type);
		if (can_move > (vec[type]-min))
			can_move = (vec[type]-min);

		if (can_move >= wanted){
			vec[type] -= wanted;

			/* resupply the supply unit */
			resupply_commod(&land, type);

			land.lnd_mobil -= roundavg(supply_mob(type,wanted,
					weight, move_cost));

			if (actually_doit){
				putvec(VT_ITEM, vec, (s_char *)&land, EF_LAND);
				putland(land.lnd_uid,&land);
			}
			return total_wanted;
		}else if (can_move > 0){
			gotten += can_move;
			wanted -= can_move;
			vec[type] -= can_move;

			land.lnd_mobil -= roundavg(supply_mob(type,can_move,
					weight, move_cost));

			if (actually_doit){
				putvec(VT_ITEM, vec, (s_char *)&land, EF_LAND);
				putland(land.lnd_uid,&land);
			}
		}
	}

	/* We've done the best we could */
	/* return the number gotten */
	return gotten;
}


s_char *
itemname(type)
int	type;
{
	register int t;
	register s_char *p;
	register struct ichrstr *ip;

	t=V_ITEM(type);
	for (ip = &ichr[1]; ip->i_mnem != 0; ip++) {
		if (t == ip->i_vtype)
			return ip->i_name;
	}
	return 0;
}

at_minimum(lp,type)
struct	lndstr *lp;
int	type;
{
	int	vec[I_MAX+1];

	getvec(VT_ITEM, vec, (s_char *)lp, EF_LAND);
	if (vec[type] <= get_minimum(lp,type))
		return 1;

	return 0;
}

/*
 * We want to get enough shells to fire once,
 * one update's worth of food, enough fuel for
 * one update.
 */

get_minimum(lp,type)
struct	lndstr *lp;
int	type;
{
	struct	lchrstr *lcp;
	int	max, want=0;
	extern	double eatrate;
	extern	int etu_per_update;
	extern	float land_mob_scale;

	lcp = &lchr[lp->lnd_type];
	max = vl_find(V_ITEM(type), lcp->l_vtype, lcp->l_vamt, (int) lcp->l_nv);

	switch (type){
#ifndef NOFOOD
		case I_FOOD:	want = ((etu_per_update * eatrate) *
					total_mil(lp))+1;
				break;
#endif /* NOFOOD */
		case I_SHELL:	want = lcp->l_ammo;
				break;
#ifdef FUEL
		/*
		 * return the amount of pet we'd need to get to 
		 * enough fuel for 1 update
		 *
		 */
		case I_PETROL:	want = (lcp->l_fuelu * (((float)etu_per_update *
					land_mob_scale))/10.0);
				want -= lp->lnd_fuel;
				if (want > 0)
					want = min(((float)want/10.0),1);

				break;
#endif /* FUEL */
		default:	return 0;
	}

	if (want > max)
		want = max;

	return want;
}

double
supply_mob(type,amount,weight,move_cost)
int	type, amount;
double	weight, move_cost;
{
	register int t=V_ITEM(type);
	register s_char *p;
	register struct ichrstr *ip;

	for (ip = &ichr[1]; ip->i_mnem != 0; ip++) {
		if (t == ip->i_vtype)
			return ((double)amount*weight*move_cost);
	}
	return 0;
}

has_supply(lp)
struct	lndstr *lp;
{
	struct	lchrstr *lcp;
	int	vec[I_MAX+1], shells_needed, shells, keepshells;
#ifdef FUEL
	int	fuel_needed, fuel, petrol_needed, petrol, keeppetrol;
#endif /* FUEL */

	lcp = &lchr[lp->lnd_type];
	getvec(VT_ITEM, vec, (s_char *)lp, EF_LAND);

	shells_needed = lcp->l_ammo;
	shells = keepshells = vec[I_SHELL];
	if (shells < shells_needed){
		vec[I_SHELL]=0;
		putvec(VT_ITEM, vec, (s_char *)lp, EF_LAND);
		shells += try_supply_commod(lp->lnd_x, lp->lnd_y, I_SHELL,
			(shells_needed-shells));
		vec[I_SHELL]=keepshells;
		putvec(VT_ITEM, vec, (s_char *)lp, EF_LAND);
	}

	if (shells < shells_needed)
		return 0;

#ifdef FUEL
	fuel_needed = lcp->l_fuelu;

	fuel = lp->lnd_fuel;

	petrol=petrol_needed = 0;

	if (fuel < fuel_needed){
		petrol_needed = ldround(((double)(fuel_needed-fuel)/10.0),1);
		petrol = keeppetrol = vec[I_PETROL];
	}

	if (petrol < petrol_needed){
		vec[I_PETROL]=0;
		putvec(VT_ITEM, vec, (s_char *)lp, EF_LAND);
		petrol += try_supply_commod(lp->lnd_x, lp->lnd_y, I_PETROL,
			(petrol_needed-petrol));
		vec[I_PETROL]=keeppetrol;
		putvec(VT_ITEM, vec, (s_char *)lp, EF_LAND);
		fuel += petrol*10;
	}

	if (fuel < fuel_needed)
		return 0;
#endif /* FUEL */

	return 1;
}

use_supply(lp)
struct	lndstr *lp;
{
	struct	lchrstr *lcp;
	int	vec[I_MAX+1], shells_needed, shells;
#ifdef FUEL
	int	fuel_needed, fuel, petrol_needed, petrol;
#endif /* FUEL */

	lcp = &lchr[lp->lnd_type];
	getvec(VT_ITEM, vec, (s_char *)lp, EF_LAND);

	shells_needed = lcp->l_ammo;
	shells = vec[I_SHELL];
	if (shells < shells_needed){
		vec[I_SHELL]=0;
		putvec(VT_ITEM, vec, (s_char *)lp, EF_LAND);
		shells += supply_commod(lp->lnd_x, lp->lnd_y, I_SHELL,
			(shells_needed-shells));
		vec[I_SHELL]=shells;
	}

	vec[I_SHELL] = max(vec[I_SHELL]-shells_needed,0);

#ifdef FUEL
	fuel_needed = lcp->l_fuelu;
	fuel = lp->lnd_fuel;

	petrol=petrol_needed = 0;

	if (fuel < fuel_needed){
		petrol_needed = ldround(((double)(fuel_needed-fuel)/10.0),1);
		petrol = vec[I_PETROL];
	}

	if (petrol < petrol_needed){
		vec[I_PETROL]=0;
		putvec(VT_ITEM, vec, (s_char *)lp, EF_LAND);
		petrol += supply_commod(lp->lnd_x, lp->lnd_y, I_PETROL,
			(petrol_needed-petrol));
		vec[I_PETROL]=petrol;
	}

	if (petrol_needed){
		if (petrol>=petrol_needed){
			vec[I_PETROL]=max(vec[I_PETROL]-petrol_needed,0);
			lp->lnd_fuel += petrol_needed * 10;
		}
		else{
			lp->lnd_fuel += vec[I_PETROL]*10;
			vec[I_PETROL]=0;
		}
	}

	lp->lnd_fuel = max(lp->lnd_fuel - fuel_needed, 0);
#endif /* FUEL */

	putvec(VT_ITEM, vec, (s_char *)lp, EF_LAND);
	putland(lp->lnd_uid,lp);
	return 1;
}
